<?php
//TITLE=Framebuffer console mode generator

$title = 'Framebuffer console mode generator';
$progname = 'fbmodes';

function usagetext($prog)
{
  exec($prog.' --help 2>&1', $kk);
  $k='';foreach($kk as $s)$k.="$s\n";
  return $k;
}

$text = array(
   '1. Purpose' => "

Give it the requested screen resolution and refresh time (vsync period),
and it gives you the modelines for fbset&nbsp;(/etc/fb.modes),
SVGATextMode&nbsp;(/etc/TextConfig) and XFree86&nbsp;(/etc/XF86Config).
<p>
On modern monitors, you probably have to specify the blank part lengths
for left, right, top and bottom of screen too.

", '1. Usage' => "

(Both are found in the same archive)

", '1.1. modetest (the newer and easier program)' => "
<pre class=smallerpre>".htmlspecialchars(usagetext('modetest'))."</pre>

(Note that you need write access to <code>/dev/vcsa0</code>
 and a working fbset (v2.1) program to fully gain the features
 this program has to offer.)

", '1.1. fbmodes (older and not so flexible program)' => "
<pre class=smallerpre>".htmlspecialchars(usagetext('fbmodes'))."</pre>

", '1. Some examples' => "
(For my \"ATY Mach64\" framebuffer and Belinea 10&nbsp;70&nbsp;20 monitor)

<pre>
mode \"2000x1750-40\"
    # D: 186.602 MHz, H: 70.683 kHz, V: 39.687 Hz
    geometry 2000 1750 2000 1750 8
    timings 5359 434 70 29 1 136 1
    hsync high
    vsync high
endmode

#~/src/fbmodes/fbmodes -x360 -y256 -d32 -ys3 -xs48 -f50000 -m1024
mode \"360x256-120\"
  geometry 360 256  360 1000  32
  timings 39746  24 72  104 53  48 3
endmode
    
#~/src/fbmodes/fbmodes -x320 -y256 -d32 -ys3 -xs48 -f50000 -m1024
mode \"320x256-120\"
  geometry 320 256  320 1000  32
  timings 43642  22 69  104 53  48 3
endmode

#~/src/fbmodes/fbmodes -x360 -xl460 -y240 -d32 -ys3 -X30 -xs20 -f35000 -m256 -r120
mode \"360x240-120\"
  geometry 360 240  360 728  32
  timings 62254  50 30  31 17  20 3
endmode

#~/src/fbmodes/fbmodes -x320 -y240 -d32 -ys2 -xs48 -f45000 -m1024
mode \"320x240-120\"
  geometry 320 240  320 1000  32
  timings 48414  22 69  88 45  48 2
endmode

#~/src/fbmodes/fbmodes -x576 -y432 -d32 -ys3 -xs48 -f50000 -m512
mode \"576x432-120\"
  geometry 576 432  576 910  32
  timings 23328  32 79  33 18  48 3
endmode

#~/src/fbmodes/modetest -x320+50/20 -y200+100/70 -r120 -X2.5e-6 -Y58e-6
mode \"320x200-120\"
    # D: 14.799 MHz, H: 36.360 kHz, V: 120.000 Hz
    geometry 320 200   320 200   8
    timings 67574  10 40  70 30  37 3
    vsync high
    hsync high
endmode

#~/src/fbmodes/modetest -x384+50/35 -y288+40/80 -r120 -X2.5e-6 -Y58e-6
mode \"384x288-120\"
    # D: 19.145 MHz, H: 39.720 kHz, V: 120.000 Hz
    geometry 384 288   384 288   8
    timings 52232  17 33  32 8  48 3
endmode

# Generated with: modetest -x256+95/40 -y320+30 -r120 -X0 -Y1e-6
mode \"256x320-120\"
    # D: 14.784 MHz, H: 42.120 kHz, V: 120.000 Hz
    geometry 256 320   256 320   32
    timings 67640  38 57  27 3  0 1
    vsync high
    hsync high
endmode

# Generated with: modetest -x400+60/48 -y320+50/60 -r120
mode \"400x320-120\"
    # D: 21.472 MHz, H: 44.640 kHz, V: 120.000 Hz
    geometry 400 320   400 320   8
    timings 46572  28 32  30 20  21 2
    vsync high
    hsync high
endmode

# Generated with: modetest -x 432+70/50 -y 320+30 -r 120
mode \"432x320-120\"
    # D: 22.071 MHz, H: 42.120 kHz, V: 120.000 Hz
    geometry 432 320   432 320   8
    timings 45308  35 35  27 3  22 1
    vsync high
    hsync high
endmode

# Generated with: modetest -x352+116/35 -y288+120/70 -r124
mode \"352x288-124\"
    # D: 25.064 MHz, H: 50.840 kHz, V: 124.000 Hz
    geometry 352 288   352 288   8
    timings 39897  40 76  84 36  25 2
    vsync high
    hsync high
endmode

# Generated with: modetest -x640+100/97 -y360+30 -r120
mode \"640x360-120\"
    # D: 36.503 MHz, H: 47.040 kHz, V: 120.000 Hz
    geometry 640 360   640 360   8
    timings 27394  97 3  27 3  36 2
    vsync high
    hsync high
endmode

# Generated with: modetest -x640+200 -y480+50 -r120
mode \"640x480-120\"
    # D: 57.264 MHz, H: 63.840 kHz, V: 120.000 Hz
    geometry 640 480   640 480   8
    timings 17462  160 40  45 5  57 2
    vsync high
    hsync high
endmode

# Generated with: modetest -x512+110/90 -y384+30 -r120
mode \"512x384-120\"
    # D: 32.648 MHz, H: 49.920 kHz, V: 120.000 Hz
    geometry 512 384   512 384   8
    timings 30630  99 11  27 3  32 2
    vsync high
    hsync high
endmode

# Generated with: modetest -x720+180/70 -y480+60/70 -r120
mode \"720x480-120\"
    # D: 62.568 MHz, H: 65.040 kHz, V: 120.000 Hz
    geometry 720 480   720 480   8
    timings 15982  126 54  42 18  62 2
    vsync high
    hsync high
endmode

</pre>

(I have made this much different screen modes to play divx videos full screen
 without software rescaling. The <a href=\"http://mplayer.sourceforge.net\">MPlayer</a>
 script be found <a href=\"/src/mplay\">here</a>.)

", '1. Copying' => "

modetest has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).
<p>
If you happen to see this program useful for you, I'd
appreciate if you tell me :) Perhaps it would motivate
me to enhance the program.

", '1. Drawbacks' => "

<ul><li>
Doublescan-modes and interlaced modes are not supported, as I am
unable to test them. The Linux atyfb driver does not implement them.
Therefore, the low resolution modes (320x200 for example) don't look as good
as you might expect.</li>
<li>
Being able to produce screenmodes like 320x1024 @ 120 fps, you might damage
your monitor while playing with these utilities. Newer monitors don't usually
suffer a lot, but older ones might. I offer no warranty whatsoever. However,
if you happen to make your monitor explode or at least damage when using this
program, you are encouraged to <a href=\"mailto:bisqwit@iki.fi\">tell me</a>
about it.</li>
<li>
The programs have *no* kind of database of standard video modes. Therefore,
when using modetest, you almost always <em>have</em> to specify the blank area
sizes and positions explicitly. It has been made as easy as possible though.</li>
<li>
Flat displays (LCD, TFT) are not so flexible in clocking as CRT displays are.
If you have a 1024x768 flat display, there most probably is no way to get 1280x1024
resolution with it. I have a 1280x1024 Belinea monitor (model 10&nbsp;70&nbsp;20),
and it can display even 2000x1750 when given suitable input.</li>
</ul>

", '1. Feedback' => "

If you have problems using this program or ideas how to
develop it, <a href=\"mailto:bisqwit@iki.fi\">email</a>
me your questions or ideas. Please do not omit the details.

", '1. Requirements' => "

Only tested with GNU make and GCC version 3.03 in Linux.<br>
Mode tester (visualizer and tester) part works only on Linux (it uses /dev/vcsa0 and fbset).<br>

", '1. Installation' => "

<pre class=smallerpre
>\$ make
\$ su
# make install</pre>

If you do not want to install
<a href=\"http://oktober.stc.cx/source/libargh.html\">libargh</a>
(included in the archive), do not use \"make install\" and edit
Makefile and enable the STATIC linking instead of DYNAMIC.

");
include '/WWW/progdesc.php';
